{lib/globals.i}
{manager/Exception.i}

DEFINE INPUT PARAMETER ipGroupID as character.
DEFINE INPUT PARAMETER ipInvoiceNum as integer.
DEFINE INPUT PARAMETER logicityPath as character.
DEFINE INPUT PARAMETER rrdPath as character.
DEFINE INPUT PARAMETER rptPath as character.
DEFINE INPUT PARAMETER odbcUser as character.
DEFINE INPUT PARAMETER odbcPassword as character.
DEFINE INPUT PARAMETER toAddress as character.
DEFINE INPUT PARAMETER fromAddress as character.
DEFINE INPUT PARAMETER subject as character.
DEFINE INPUT PARAMETER body as character.
DEFINE INPUT PARAMETER smtpServer as character.
DEFINE INPUT PARAMETER smtpUser as character.
DEFINE INPUT PARAMETER smtpPassword as character.

{&TRY_PRIVATE}

    DEF VAR lReturnCode AS INTEGER NO-UNDO. 
    DEF VAR sNullString AS CHARACTER NO-UNDO.
    DEF VAR commandLineParameter AS CHARACTER NO-UNDO.
    logicityPath = '"' + logicityPath + '"'.
    rrdPath = '"' + rrdPath + '"'.
    rptPath = '"' + rptPath + '"'.
    subject = '"' + subject + '"'.
    body = '"' + body + '"'.

    IF ipInvoiceNum<>0 THEN DO:
        commandLineParameter = rrdPath + ' INVOICENUM=' + STRING(ipInvoiceNum) + ';RPTPATH=' + rptPath + ';ODBCUSER=' + odbcUser + ';ODBCPASSWORD=' + odbcPassword + ';TOADDRESS=' + toAddress + ';SUBJECT=' + subject + ';BODY=' + body + ';SMTPSERVER=' + smtpServer + ';SMTPUSER=' + smtpUser + ';SMTPPASSWORD=' + smtpPassword + ';FROMADDRESS=' + fromAddress.
        MESSAGE commandLineParameter.
        RUN ShellExecuteA ( INPUT 0, 
                        INPUT "open", 
                        INPUT logicityPath, /*The application or file that you wish to run*/ 
                        INPUT commandLineParameter, /*command line parameters to be passed with it*/ 
                        INPUT sNullString, 
                        INPUT 2, 
                        OUTPUT lReturnCode). 
    END.
    ELSE DO:
        FOR EACH InvcHead WHERE InvcHead.Company=cur-comp AND InvcHead.GroupID = ipGroupID NO-LOCK:
        commandLineParameter = rrdPath + ' INVOICENUM=' + STRING(ipInvoiceNum) + ';RPTPATH=' + rptPath + ';ODBCUSER=' + odbcUser + ';ODBCPASSWORD=' + odbcPassword + ';TOADDRESS=' + toAddress + ';SUBJECT=' + subject + ';BODY=' + body + ';SMTPSERVER=' + smtpServer + ';SMTPUSER=' + smtpUser + ';SMTPPASSWORD=' + smtpPassword + ';FROMADDRESS=' + fromAddress.
    
            RUN ShellExecuteA ( INPUT 0, 
                            INPUT "open", 
                            INPUT logicityPath, /*The application or file that you wish to run*/ 
                            INPUT commandLineParameter, /*command line parameters to be passed with it*/ 
                            INPUT sNullString, 
                            INPUT 2, 
                            OUTPUT lReturnCode). 
        END.
    END.




{&CATCH_PRIVATE}

PROCEDURE ShellExecuteA EXTERNAL "SHELL32.DLL":     
    DEF INPUT PARAM hWnd AS LONG.     
    DEF INPUT PARAM lpOperation AS CHARACTER.     
    DEF INPUT PARAM lpFile AS CHARACTER.     
    DEF INPUT PARAM lpParameters AS CHARACTER.     
    DEF INPUT PARAM lpDirectory AS CHARACTER.     
    DEF INPUT PARAM nShowCmd AS LONG.     
    DEF RETURN PARAM lStatusCode AS LONG. 
END PROCEDURE. 
