{lib/globals.i}
{manager/Exception.i}

DEFINE INPUT PARAMETER ipGroupID as character.
DEFINE INPUT PARAMETER ipInvoiceNum as integer.
DEFINE INPUT PARAMETER logicityPath as character.
DEFINE INPUT PARAMETER rrdPath as character.
DEFINE INPUT PARAMETER rptPath as character.
DEFINE INPUT PARAMETER printerName as character.
DEFINE INPUT PARAMETER odbcUser as character.
DEFINE INPUT PARAMETER odbcPassword as character.
{&TRY_PRIVATE}

    DEF VAR lReturnCode AS INTEGER NO-UNDO. 
    DEF VAR sNullString AS CHARACTER NO-UNDO.
    DEF VAR commandLineParameter AS CHARACTER NO-UNDO.
    logicityPath = '"' + logicityPath + '"'.
    rrdPath = '"' + rrdPath + '"'.
    rptPath = '"' + rptPath + '"'.
    printerName = '"' + printerName + '"'.

    IF ipInvoiceNum<>0 THEN DO:
        commandLineParameter = rrdPath + ' INVOICENUM=' + STRING(ipInvoiceNum) + ';RPTPATH=' + rptPath + ';ODBCUSER=' + odbcUser + ';ODBCPASSWORD=' + odbcPassword + ';PRINTERNAME=' + printerName.

        RUN ShellExecuteA ( INPUT 0, 
                        INPUT "open", 
                        INPUT logicityPath, /*The application or file that you wish to run*/ 
                        INPUT commandLineParameter, /*command line parameters to be passed with it*/ 
                        INPUT sNullString, 
                        INPUT 2, 
                        OUTPUT lReturnCode). 
    END.
    ELSE DO:
        FOR EACH InvcHead WHERE InvcHead.Company=cur-comp AND InvcHead.GroupID = ipGroupID NO-LOCK:
            commandLineParameter = rrdPath + ' INVOICENUM=' + STRING(ipInvoiceNum) + ';RPTPATH=' + rptPath + ';ODBCUSER=' + odbcUser + ';ODBCPASSWORD=' + odbcPassword + ';PRINTERNAME=' + printerName.
    
            RUN ShellExecuteA ( INPUT 0, 
                            INPUT "open", 
                            INPUT logicityPath, /*The application or file that you wish to run*/ 
                            INPUT commandLineParameter, /*command line parameters to be passed with it*/ 
                            INPUT sNullString, 
                            INPUT 2, 
                            OUTPUT lReturnCode). 
        END.
    END.




{&CATCH_PRIVATE}

PROCEDURE ShellExecuteA EXTERNAL "SHELL32.DLL":     
    DEF INPUT PARAM hWnd AS LONG.     
    DEF INPUT PARAM lpOperation AS CHARACTER.     
    DEF INPUT PARAM lpFile AS CHARACTER.     
    DEF INPUT PARAM lpParameters AS CHARACTER.     
    DEF INPUT PARAM lpDirectory AS CHARACTER.     
    DEF INPUT PARAM nShowCmd AS LONG.     
    DEF RETURN PARAM lStatusCode AS LONG. 
END PROCEDURE. 
